"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pendingSource = exports.nullSource = exports.constant = exports.identitySelector = exports.subscribe = exports.hasSnapshot = exports.getSnapshotPromise = exports.getSnapshot = exports.act = void 0;
const retil_support_1 = require("retil-support");
function act(source, callback) {
    return source[2](callback);
}
exports.act = act;
function getSnapshot([[getVersion], select,]) {
    return select(getVersion());
}
exports.getSnapshot = getSnapshot;
function getSnapshotPromise([[getVersion], select,]) {
    try {
        return Promise.resolve(select(getVersion()));
    }
    catch (errorOrPromise) {
        if (retil_support_1.isPromiseLike(errorOrPromise)) {
            return Promise.resolve(errorOrPromise).then(() => select(getVersion()));
        }
        return Promise.reject(errorOrPromise);
    }
}
exports.getSnapshotPromise = getSnapshotPromise;
function hasSnapshot([[getVersion]]) {
    try {
        getVersion();
    }
    catch (errorOrPromise) {
        if (retil_support_1.isPromiseLike(errorOrPromise)) {
            return false;
        }
    }
    return true;
}
exports.hasSnapshot = hasSnapshot;
function subscribe([[, subscribe]], onChange, onSeal) {
    return subscribe(onChange, onSeal);
}
exports.subscribe = subscribe;
const constantSubscribe = (_change, seal) => {
    if (seal) {
        seal();
    }
    return retil_support_1.noop;
};
const constantAct = (cb) => Promise.resolve(cb());
const identitySelector = (value) => value;
exports.identitySelector = identitySelector;
const constant = (value) => [
    [() => value, constantSubscribe],
    retil_support_1.identity,
    constantAct,
];
exports.constant = constant;
exports.nullSource = [
    [() => null, constantSubscribe],
    retil_support_1.identity,
    constantAct,
];
exports.pendingSource = [
    [
        () => {
            throw retil_support_1.pendingPromiseLike;
        },
        constantSubscribe,
    ],
    retil_support_1.identity,
    constantAct,
];
