import { Maybe } from 'retil-support';
import { Source } from './source';
export declare const FuseEffectSymbol: unique symbol;
export declare type FuseEffect = typeof FuseEffectSymbol;
export declare type FusorEffect = (callback: () => any) => FuseEffect;
export declare type FusorUse = <U, V = U>(source: Source<U>, ...defaultValues: Maybe<V>) => U | V;
export declare type Fusor<T> = (use: FusorUse, effect: FusorEffect) => T | FuseEffect;
export declare function fuse<T>(fusor: Fusor<T>, onTeardown?: () => void): Source<T>;
