import { Source } from './source';
export interface StateController<T> {
    (state: T): void;
    (updater: (state: T) => T): void;
}
export declare type StateSealer = () => void;
export declare function createState<T>(initialState?: T, isEqual?: (x: T, y: T) => boolean): readonly [Source<T>, StateController<T>, StateSealer];
